package com.stevel05.onHover;


import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import android.os.Build;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnGenericMotionListener;

@ShortName("OnHover")
@Author("Steve Laming")
@Version(1)
@ActivityObject


/**
*	Simple one method lib for use with CustomView
 */

public class onHover  {

	private String eventSub;
	private static final int Api = Build.VERSION.SDK_INT;

	
	/* Set an onGenericMotionListener or OnHover on View dependent on Api Level
	 * Api 12 & 13 get an onGenericMotionEvent, Api 14+ get an onHover event.
	 *Callback requires a sub with signature of 
	 *eventName(viewTag As Object,Action As int,X As float,Y As Float,MotionEvent As Object) 
	 **/
	public void setCallBack(final BA ba,final View view, String EventName) {
		
		eventSub = EventName.toLowerCase(BA.cul);
		if (Api >= 12 && Api < 14) {
			Log.v("B4A", "Api "+Api+": onGenericMotionListener created");
		    view.setOnGenericMotionListener(new View.OnGenericMotionListener() {
				
				public boolean onGenericMotion(View v, MotionEvent event) {
						Object result = ba.raiseEvent(v, eventSub , new Object[] {v.getTag(),Integer.valueOf(event.getAction()), Float.valueOf(event.getX()), Float.valueOf(event.getY()),event});
						if (result != null)
						{
						return ((Boolean)result).booleanValue();
						}
					return true;
				}
			});
		}
		if(Api >= 14) {
			Log.v("B4A", "Api "+Api+": onHoverListener created");
		    view.setOnHoverListener(new View.OnHoverListener() {
				
				public boolean onHover(View v,MotionEvent event) {
						Object result = ba.raiseEvent(v, eventSub , new Object[] {v.getTag(),Integer.valueOf(event.getAction()), Float.valueOf(event.getX()), Float.valueOf(event.getY()),event});
						if (result != null)
						{
						return ((Boolean)result).booleanValue();
						}
					return true;
				}
				
		    });
		}
		if (Api < 12) {
			Log.v("B4A", "Api "+Api+": Listener NOT created");
		}
	}
}
	

